File vnstat.init of Package vnstat
#!/bin/sh
#
# openSUSE system startup script for vnstatd.
# Copyright (C) 2009 Pascal Bleser <[email protected]>
#
# This library is free software; you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or (at
# your option) any later version.
#
# This library is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
### BEGIN INIT INFO
# Provides: vnstatd
# Required-Start: $syslog $remote_fs $network
# Should-Start: $time
# Required-Stop: $syslog $remote_fs $network
# Should-Stop: $time
# Default-Start: 3 5
# Default-Stop: 0 1 2 6
# Short-Description: vnstatd daemon providing network traffic accounting
# Description: Start vnstatd to record network traffic
### END INIT INFO
# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance
VNSTATD_BIN=/usr/sbin/vnstatd
test -x "$VNSTATD_BIN" || { echo "$VNSTATD_BIN not installed";
if [ "$1" = "stop" ]; then exit 0;
else exit 5; fi; }
VNSTATD_PIDFILE=/var/run/vnstatd.pid
VNSTATD_USER=vnstat
. /etc/rc.status
# Reset status of this service
rc_reset
case "$1" in
start)
echo -n "Starting vnstatd "
"$VNSTATD_BIN" -d -p "$VNSTATD_PIDFILE"
# Remember status and be verbose
rc_status -v
;;
stop)
echo -n "Shutting down vnstatd "
## Stop daemon with killproc(8) and if this fails
## killproc sets the return value according to LSB.
/sbin/killproc -TERM "$VNSTATD_BIN"
# Remember status and be verbose
rc_status -v
;;
try-restart|condrestart)
## Do a restart only if the service was active before.
## Note: try-restart is now part of LSB (as of 1.9).
## RH has a similar command named condrestart.
if test "$1" = "condrestart"; then
echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
fi
$0 status
if test $? = 0; then
$0 restart
else
rc_reset # Not running is not a failure.
fi
# Remember status and be quiet
rc_status
;;
restart)
## Stop the service and regardless of whether it was
## running or not, start it again.
$0 stop
$0 start
# Remember status and be quiet
rc_status
;;
force-reload)
## Signal the daemon to reload its config. Most daemons
## do this on signal 1 (SIGHUP).
## If it does not support it, restart the service if it
## is running.
echo -n "Reload service vnstatd "
## if it supports it:
/sbin/killproc -HUP "$VNSTATD_BIN"
touch "$VNSTATD_PIDFILE"
rc_status -v
;;
reload)
## Like force-reload, but if daemon does not support
## signaling, do nothing (!)
# If it supports signaling:
echo -n "Reload service vnstatd "
/sbin/killproc -HUP "$VNSTATD_BIN"
touch "$VNSTATD_PIDFILE"
rc_status -v
;;
status)
echo -n "Checking for service vnstatd "
## Check status with checkproc(8), if process is running
## checkproc will return with exit status 0.
/sbin/checkproc "$VNSTATD_BIN"
# NOTE: rc_status knows that we called this init script with
# "status" option and adapts its messages accordingly.
rc_status -v
;;
probe)
## Optional: Probe for the necessity of a reload, print out the
## argument to this init script which is required for a reload.
## Note: probe is not (yet) part of LSB (as of 1.9)
test /etc/vnstat.conf -nt "$VNSTATD_PIDFILE" && echo reload
;;
*)
echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
exit 1
;;
esac
rc_exit